;Include constants
#include <GUIConstants.au3>

; Modification: 22/03/2007

;Initialize variables
Global $GUIWidth
Global $GUIHeight

$GUIWidth = 300
If FileExists("c:\temp\clone\se3.bat") Then
	$GUIHeight = 150
Else
	$GUIHeight = 180
EndIf

; Initialisation:
$NOMPC=""
$IP=""
$WORKGRP=""
$MAC=""

Func verif_ip($ip)
	; Contrle des saisies:
	$erreur = "non"
	$ip_sans_point = StringReplace($ip,".","")
	$nombre_de_remplacements = @extended
	If StringIsDigit($ip_sans_point) AND $nombre_de_remplacements == 3  Then
		$octet = StringSplit($ip,".")
		; $octet[0] donne le nombre d'indices du tableau.
		For $i = 1 to 4
			;MsgBox(0,"Info","octet[" & $i & "] = " & $octet[$i])
			If $octet[$i] < 0 OR $octet[$i] > 255 Then
				$erreur = "oui"
				ExitLoop
			EndIf
		Next
	Else
		$erreur = "oui"
	EndIf

	;MsgBox(0,"Info","erreur = " & $erreur)

	If $erreur == "oui" Then
		MsgBox(0, "Erreur", "Un champ contient des caractres non valides" & @CRLF & "ou ne contient pas les 4 octets spars par des points.")
		return "erreur"
	EndIf
EndFunc

If IsAdmin() Then

	If FileExists("C:\temp\clone\nettoyage.txt") Then
		; ======================================
		; =           DERNIERE PHASE           =
		; ======================================
		; La dernire phase est:
		; - soit la deuxime (dans le cas o on n'intgre pas un domaine SambaEdu3)
		; - soit la troisime (dans le cas o on intgre un domaine SambaEdu3)

		; Peut-tre faudra-t-il utiliser un lanceur batch avec une pause et faire exit dans ce script.
		;Run("c:\temp\nettoye2.exe")
        MsgBox(0, "Info", "Lancement du nettoyage...",1)
        RunWait("c:\temp\nettoye2.exe")
		Run(@ComSpec & " /c del c:\temp\nettoye2.exe")
		Exit
	Else
		If FileExists("c:\temp\clone\se3.bat") AND FileExists("c:\temp\clone\temoin.txt") Then
			; ======================================
			; =           DEUXIEME PHASE           =
			; ======================================
			;=======================================================
			; Cration du fichier tmoin pour lancer le nettoyage aprs le reboot
			$FICHNETTOYAGE = FileOpen("C:\temp\clone\nettoyage.txt",2)
			If $FICHNETTOYAGE = -1 Then
				MsgBox(0, "Erreur", "Il n'a pas t possible de crer le fichier 'C:\temp\clone\nettoyage.txt'!")
				Exit
			EndIf

			FileWriteLine($FICHNETTOYAGE,"Nettoyage  effectuer...")
			FileClose($FICHNETTOYAGE)

			; En principe les deux valeurs suivantes sont modifies par le rejoin_se3_XP
			; Le nettoyage qui est fait l est donc superflu.
			RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon","DefaultPassword")
			RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon","AutoAdminLogon","REG_SZ","0")

			;=======================================================

			;RunWait("c:\temp\clone\se3.bat")
			; Changement pour tenir compte des demandes de confirmation: SP2 et aussi choix Tlcharger/Ouvrir
			Run("c:\temp\clone\se3.bat")

			If WinWait("Fichier ouvert - Avertissement de scurit","Voulez-vous ouvrir ce fichier?",80) Then
				WinMove("Fichier ouvert - Avertissement de scurit","Voulez-vous ouvrir ce fichier?",0,0)
				Sleep(500)
				MouseClick("left",257,173)
			EndIf

			If WinWait("Tlchargement de fichier","Certains fichiers peuvent endommager votre ordinateur. Si les informations sur le fichier ci-dessous semblent suspectes, n'ouvrez ou n'enregistrez pas ce fichier.",20) Then
				WinMove("Tlchargement de fichier","Certains fichiers peuvent endommager votre ordinateur. Si les informations sur le fichier ci-dessous semblent suspectes, n'ouvrez ou n'enregistrez pas ce fichier.",0,0)
				Sleep(500)
				MouseClick("left",99,238)
			EndIf

			; Mnage:
			; A partir de l, on n'a plus besoin du mot de passe du compte admin de SE3
			FileRecycle("C:\temp\clone\admin_mdp.bat")
			FileRecycleEmpty()

		Else
			; ======================================
			; =           PREMIERE PHASE           =
			; ======================================

			If FileExists("c:\temp\clone\clients.ini") Then
				#include <lecture_clients_ini.au3>
			EndIf

			If FileExists("c:\temp\clone\correspondance_nom_mac_ip.ini") Then
				#include <lecture_correspondance_nom_mac_ip_ini.au3>
			EndIf

			; $IP et $NOMPC ont pu tre rcuprs des deux scripts prcdents.
			If $IP <> "" AND $NOMPC <> "" Then
				If $IP == "DHCP" Then
					$IP = ""
				EndIf

			Else
				; Il va falloir demander l'un des paramtres au moins  l'utilisateur.

				If $IP <> "DHCP" Then
                    ; Prfixe IP  proposer:
                    $PREFIP=""
                    If FileExists("C:\temp\clone\param.ini") Then
                        $FICHPARAM = FileOpen("C:\temp\clone\param.ini",0)
                        If $FICHPARAM = -1 Then
                            MsgBox(0, "Erreur", "Il n'a pas t possible d'ouvrir le fichier 'C:\temp\clone\param.ini'!" & @CRLF & "Ce fichier permet de personnaliser le paquet post-clonage pour proposer des choix par dfaut adapts  votre rseau.")
                        Else
                            While 1
                                $LIGNE = FileReadLine($FICHPARAM)
                                ;MsgBox(0,"Info",$LIGNE)
                                If @error = -1 Then ExitLoop
                                If StringInStr ($LIGNE,"PREFIP=") <> 0 Then
                                    ;MsgBox(0,"Info","Ligne trouve:" & $LIGNE)
                                    $TEMP = StringSplit($LIGNE, "=")
                                    $PREFIP = $TEMP[2]
                                    ExitLoop
                                EndIf
                            Wend
                            FileClose($FICHPARAM)
                        EndIf
                    EndIf
                EndIf

				; Cration de la fentre
				GUICreate("Corrections POST-CLONAGE", $GUIWidth, $GUIHeight)

				$x0=10
				$x1=160
				$y0=10

				; Affichage d'un titre:
				$Label_info = GuiCtrlCreateLabel("Veuillez saisir les nouveaux paramtres:", $x0, $y0, 200, 20, $SS_SUNKEN)

				$y0=$y0+30
				$y1=$y0+3

				; Cration des champs de formulaire:
				$DHCP = "non"
				If FileExists("C:\temp\clone\temoin_dhcp.txt") Then
					$Label_DHCP = GuiCtrlCreateLabel("Le poste est client DHCP.", $x0, $y1, 150, 20)
					$DHCP = "oui"
				Else
					$Label_IP = GuiCtrlCreateLabel("Nouvelle adresse IP:", $x0, $y1, 150, 20)
					;$Champ_IP = GUICtrlCreateInput("10.127.", $x1, $y0, 130, 20)
					$Champ_IP = GUICtrlCreateInput($PREFIP, $x1, $y0, 130, 20)
				EndIf

				$y0=$y0+30
				$y1=$y0+3

				If $NOMPC <> "" Then
					$Label_NOM = GuiCtrlCreateLabel("Nom de machine:", $x0, $y1, 150, 20)
					$Label_NOM2 = GuiCtrlCreateLabel($NOMPC, $x1, $y0, 130, 20, $SS_SUNKEN)
				Else
					$Label_NOM = GuiCtrlCreateLabel("Nouveau nom de machine:", $x0, $y1, 150, 20)
					$Champ_NOM = GUICtrlCreateInput("", $x1, $y0, 130, 20)
				EndIf

				; On ne propose le changement de workgroup que si on ne joint pas un domaine SambaEdu3:
				If FileExists("c:\temp\clone\se3.bat") Then
					$bidon = "oui"
				Else

					$y0=$y0+30
					$y1=$y0+3

					; Ajout d'aprs Fabien Malfoy (monkey@indriya.org):
					$Label_WORKGRP = GUICtrlCreateLabel("Nouveau workgroup (ou vide):", $x0, $y1, 150, 20)
					$Champ_WORKGRP = GUICtrlCreateInput("", $x1, $y0, 130, 20)

					; Il faudrait pouvoir initialiser ce nom de workgroup... (?)
					; Quitte  rcuprer le nom de workgroup courant... (autant le faire avant le clonage...
					; (stocker le nom de workgroup))
				EndIf


				$y0=$y0+40

				$x=($GUIWidth-2*70-35)/2

				; Cration du bouton "OK"
				$OK_Btn = GUICtrlCreateButton("OK", $x, $y0, 70, 25)

				$x=$x+70+35

				; Cration du bouton "CANCEL"
				$Cancel_Btn = GUICtrlCreateButton("Cancel", $x, $y0, 70, 25)

				; On rend la fentre visible (modification de statut)
				GUISetState(@SW_SHOW)

				; On fait une boucle jusqu' ce que:
				; - l'utilisateur presse ESC
				; - l'utilisateur presse ALT+F4
				; - l'utilisateur clique sur le bouton de fermeture de la fentre
				While 1
					; Aprs chaque boucle, on contrle si l'utilisateur a cliqu sur quelque chose
					$msg = GUIGetMsg()

					Select
						; On teste si l'utilisateur a cliqu sur le bouton de fermeture
						Case $msg = $GUI_EVENT_CLOSE
							; On dtruit la fentre et ses contrles
							GUIDelete()
							; Et on quitte le script
							Exit

						; On teste si l'utilisateur a cliqu sur le bouton OK
						Case $msg = $OK_Btn
							;GUISetState(@SW_HIDE)

							$SORTIE=""

							;=======================================================
							; Rcupration du contenu des champs de formulaire
							If $NOMPC == "" Then
								$NOMPC = GUICtrlRead($Champ_NOM)
								;If StringIsAlNum(StringReplace($NOMPC,"_","")) == 0 Then
								; On accepte aussi le '-' dans les noms de machines.
								; En fait le '_' devrait tre interdit d'aprs Fabien Malfoy <monkey@indriya.org>
								If StringIsAlNum(StringReplace(StringReplace($NOMPC,"_",""),"-","")) == 0 Then
									MsgBox(0,"Erreur","Le nom choisi n'est pas valide!")
									;Exit
									$SORTIE = "oui"
									$NOMPC=""
								EndIf
							EndIf

							If $DHCP == "oui" Then
								$IP = ""
							Else
								$IP = GUICtrlRead($Champ_IP)
								If verif_ip($IP) == "erreur" Then
									MsgBox(0,"Erreur","L'adresse IP propose n'est pas valide!")
									;Exit
									$SORTIE = "oui"
								EndIf
							EndIf

							If FileExists("c:\temp\clone\se3.bat") Then
								$bidon="oui"
							Else
								; Ajout d'aprs Fabien Malfoy (monkey@indriya.org):
								$WORKGRP = GUICtrlRead($Champ_WORKGRP)
								If $WORKGRP == "" Then
									$bidon = "Pas de changement de Workgroup."
								Else
									If StringIsAlNum(StringReplace(StringReplace($WORKGRP,"_",""),"-","")) == 0 Or $WORKGRP == $NOMPC Then
										MsgBox(0,"Erreur","Le groupe de travail choisi n'est pas valide!")
										;Exit
										$SORTIE = "oui"
									EndIf
								EndIf
							EndIf

							;=======================================================

							If $SORTIE == "oui" Then
								$bidon=""
								; On va arriver au WEnd en sortie du If
								GUISetState(@SW_SHOW)
								; Et l'utilisateur va pouvoir effectuer une autre saisie.
							Else
								; S'il n'y a pas d'erreur de saisie on poursuit les oprations.

								; Les paramtrages vont tre effectus hors de la boucle.

								GUIDelete()
								ExitLoop
							EndIf

						; On teste si l'utilisateur a cliqu sur le bouton CANCEL
						Case $msg = $Cancel_Btn
							MsgBox(64, "Abandon!", "Vous avez souhait abandonner les corrections.")
							GUIDelete()
							Exit
					EndSelect
				WEnd
			EndIf

			; En sortie de boucle sans 'Exit' les paramtres sont renseigns,
			; On peut procder au re-paramtrage.
			;=======================================================
			; Cration du fichier IP.BAT
			$FICHIP = FileOpen("C:\temp\clone\ip.bat",2)
			If $FICHIP = -1 Then
				MsgBox(0, "Erreur", "Il n'a pas t possible de crer le fichier 'C:\temp\clone\ip.bat'!")
				Exit
			EndIf

			FileWriteLine($FICHIP,"set IP=" & $IP)
			FileClose($FICHIP)
			;=======================================================


			;=======================================================
			; Cration du fichier NOMPC.BAT
			$FICHNOMPC = FileOpen("C:\temp\clone\nompc.bat",2)
			If $FICHNOMPC = -1 Then
				MsgBox(0, "Erreur", "Il n'a pas t possible de crer le fichier 'C:\temp\clone\nompc.bat'!")
				Exit
			EndIf

			FileWriteLine($FICHNOMPC,"set NOMPC=" & $NOMPC)
			FileClose($FICHNOMPC)
			;=======================================================


			If FileExists("c:\temp\clone\se3.bat") Then
				$bidon="oui"
			Else
				If $WORKGRP == "" Then
					$bidon = "Pas de changement de Workgroup."
				Else
					; Ajout d'aprs Fabien Malfoy <monkey@indriya.org>:
					;=======================================================
					; Cration du fichier WORKGRP.BAT
					$FICHWORKGRP = FileOpen("C:\temp\clone\workgrp.bat",2)
					If $FICHWORKGRP = -1 Then
						MsgBox(0, "Erreur", "Il n'a pas t possible de crer le fichier 'C:\temp\clone\workgrp.bat'!")
						Exit
					EndIf

					FileWriteLine($FICHWORKGRP,"set WORKGRP=" & $WORKGRP)
					FileClose($FICHWORKGRP)
					;=======================================================
				EndIf
			EndIf


			;GUISetState(@SW_HIDE)

			RunWait("c:\temp\clone\corrigboot.bat")
			RunWait("c:\temp\clone\modifip4.bat")

			If FileExists("c:\temp\clone\temoin_copie_nettoye.txt") Then
				$bidon="truc"
			Else
				If FileExists("c:\temp\clone\copie_nettoye.bat") Then
					RunWait("C:\temp\clone\copie_nettoye.bat")
				EndIf
				If FileExists("c:\temp\clone\net_use_se3_progs.bat") Then
					RunWait("C:\temp\clone\net_use_se3_progs.bat")
					; L'existence du rejoin_se3_XP_clone.vbs est teste dans le script ci-dessous:
					#include <rejoin_se3_clone.au3>
					#include <rejoinsambaedu3_clone.au3>
					RunWait("C:\temp\clone\net_delete_se3_progs.bat")
				EndIf
			EndIf

			;=======================================================
			; Cration du fichier tmoin pour le premier reboot
			; Ce tmoin signale que le changement IP et SID sont effectus.
			; (pour le SID, le changement se fait sur cette session, quelques lignes plus bas)
			; Il restera alors  effectuer si ncessaire la jonction au domaine SE3 et le nettoyage.
			$FICHTEMOIN = FileOpen("C:\temp\clone\temoin.txt",2)
			If $FICHTEMOIN = -1 Then
				MsgBox(0, "Erreur", "Il n'a pas t possible de crer le fichier 'C:\temp\clone\temoin.txt'!")
				Exit
			EndIf

			FileWriteLine($FICHTEMOIN,"Etape 1 effectue...")
			FileClose($FICHTEMOIN)
			;=======================================================

			If FileExists("c:\temp\clone\se3.bat") Then
				$temoin = "bidon"
			Else
				; Il n'est pas ncessaire de joindre un domaine SE3,
				; il ne reste donc que le nettoyage  effectuer aprs le reboot.
				;=======================================================
				; Cration du fichier tmoin pour lancer le nettoyage aprs le reboot
				$FICHNETTOYAGE = FileOpen("C:\temp\clone\nettoyage.txt",2)
				If $FICHNETTOYAGE = -1 Then
					MsgBox(0, "Erreur", "Il n'a pas t possible de crer le fichier 'C:\temp\clone\nettoyage.txt'!")
					Exit
				EndIf

				FileWriteLine($FICHNETTOYAGE,"Nettoyage  effectuer...")
				FileClose($FICHNETTOYAGE)

				; Suppression de l'autologon avant le nettoyage.
				; Peut-tre un dernier logon de nettoyage suivi d'un reboot serait-il plus judicieux.
				RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon","DefaultPassword")
				RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon","AutoAdminLogon","REG_SZ","0")

				;=======================================================
			EndIf

			RunWait("c:\temp\clone\new_sid.bat")

		EndIf
	EndIf
Else
	MsgBox(0,"Information","Ce programme doit tre excut avec les droits administrateur.")
	Exit
EndIf
Exit
